//@ts-nocheck
/* tslint:disable */
/* eslint-disable */
/**
 * Runtime Common Library
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { exists, mapValues } from '../runtime';
import {
    ApigeeAttribute,
    ApigeeAttributeFromJSON,
    ApigeeAttributeFromJSONTyped,
    ApigeeAttributeToJSON,
    ApigeeGraphQLOperationGroup,
    ApigeeGraphQLOperationGroupFromJSON,
    ApigeeGraphQLOperationGroupFromJSONTyped,
    ApigeeGraphQLOperationGroupToJSON,
    ApigeeOperationGroup,
    ApigeeOperationGroupFromJSON,
    ApigeeOperationGroupFromJSONTyped,
    ApigeeOperationGroupToJSON,
} from './';

/**
 * 
 * @export
 * @interface ApigeeProduct
 */
export interface ApigeeProduct {
    /**
     * 
     * @type {Array<string>}
     * @memberof ApigeeProduct
     */
    apiResources?: Array<string>;
    /**
     * Flag that specifies how API keys are approved to access the APIs defined by the API product. If set to `manual`, the consumer key is generated and returned in "pending" state. In this case, the API keys won't work until they have been explicitly approved. If set to `auto`, the consumer key is generated and returned in "approved" state and can be used immediately. **Note:** Typically, `auto` is used to provide access to free or trial API products that provide limited quota or capabilities.
     * @type {string}
     * @memberof ApigeeProduct
     */
    approvalType?: string;
    /**
     * Array of attributes that may be used to extend the default API product profile with customer-specific metadata. You can specify a maximum of 18 attributes. Use this property to specify the access level of the API product as either `public`, `private`, or `internal`. Only products marked `public` are available to developers in the Apigee developer portal. For example, you can set a product to `internal` while it is in development and then change access to `public` when it is ready to release on the portal. API products marked as `private` do not appear on the portal, but can be accessed by external developers.
     * @type {Array<ApigeeAttribute>}
     * @memberof ApigeeProduct
     */
    attributes?: Array<ApigeeAttribute>;
    /**
     * Response only. Creation time of this environment as milliseconds since epoch.
     * @type {string}
     * @memberof ApigeeProduct
     */
    createdAt?: string;
    /**
     * Description of the API product. Include key information about the API product that is not captured by other fields. Comma-separated list of API resources to be bundled in the API product. By default, the resource paths are mapped from the `proxy.pathsuffix` variable. The proxy path suffix is defined as the URI fragment following the ProxyEndpoint base path. For example, if the `apiResources` element is defined to be `/forecastrss` and the base path defined for the API proxy is `/weather`, then only requests to `/weather/forecastrss` are permitted by the API product. You can select a specific path, or you can select all subpaths with the following wildcard: - `/**`: Indicates that all sub-URIs are included. - `/*` : Indicates that only URIs one level down are included. By default, / supports the same resources as /** as well as the base path defined by the API proxy. For example, if the base path of the API proxy is `/v1/weatherapikey`, then the API product supports requests to `/v1/weatherapikey` and to any sub-URIs, such as `/v1/weatherapikey/forecastrss`, `/v1/weatherapikey/region/CA`, and so on. For more information, see Managing API products.
     * @type {string}
     * @memberof ApigeeProduct
     */
    description?: string;
    /**
     * Name displayed in the UI or developer portal to developers registering for API access.
     * @type {string}
     * @memberof ApigeeProduct
     */
    displayName?: string;
    /**
     * Comma-separated list of environment names to which the API product is bound. Requests to environments that are not listed are rejected. By specifying one or more environments, you can bind the resources listed in the API product to a specific environment, preventing developers from accessing those resources through API proxies deployed in another environment. This setting is used, for example, to prevent resources associated with API proxies in `prod` from being accessed by API proxies deployed in `test`.
     * @type {Array<string>}
     * @memberof ApigeeProduct
     */
    environments?: Array<string>;
    /**
     * 
     * @type {ApigeeGraphQLOperationGroup}
     * @memberof ApigeeProduct
     */
    graphqlOperationGroup?: ApigeeGraphQLOperationGroup;
    /**
     * Response only. Modified time of this environment as milliseconds since epoch.
     * @type {string}
     * @memberof ApigeeProduct
     */
    lastModifiedAt?: string;
    /**
     * Internal name of the API product. Characters you can use in the name are restricted to: `A-Z0-9._\-$ %`. **Note:** The internal name cannot be edited when updating the API product.
     * @type {string}
     * @memberof ApigeeProduct
     */
    name?: string;
    /**
     * 
     * @type {ApigeeOperationGroup}
     * @memberof ApigeeProduct
     */
    operationGroup?: ApigeeOperationGroup;
    /**
     * Comma-separated list of API proxy names to which this API product is bound. By specifying API proxies, you can associate resources in the API product with specific API proxies, preventing developers from accessing those resources through other API proxies. Apigee rejects requests to API proxies that are not listed. **Note:** The API proxy names must already exist in the specified environment as they will be validated upon creation.
     * @type {Array<string>}
     * @memberof ApigeeProduct
     */
    proxies?: Array<string>;
    /**
     * Number of request messages permitted per app by this API product for the specified `quotaInterval` and `quotaTimeUnit`. For example, a `quota` of 50, for a `quotaInterval` of 12 and a `quotaTimeUnit` of hours means 50 requests are allowed every 12 hours.
     * @type {string}
     * @memberof ApigeeProduct
     */
    quota?: string;
    /**
     * Time interval over which the number of request messages is calculated.
     * @type {string}
     * @memberof ApigeeProduct
     */
    quotaInterval?: string;
    /**
     * Time unit defined for the `quotaInterval`. Valid values include `minute`, `hour`, `day`, or `month`.
     * @type {string}
     * @memberof ApigeeProduct
     */
    quotaTimeUnit?: string;
    /**
     * Comma-separated list of OAuth scopes that are validated at runtime. Apigee validates that the scopes in any access token presented match the scopes defined in the OAuth policy associated with the API product.
     * @type {Array<string>}
     * @memberof ApigeeProduct
     */
    scopes?: Array<string>;
}

export function ApigeeProductFromJSON(json: any): ApigeeProduct {
    return ApigeeProductFromJSONTyped(json, false);
}

export function ApigeeProductFromJSONTyped(json: any, ignoreDiscriminator: boolean): ApigeeProduct {
    if ((json === undefined) || (json === null)) {
        return json;
    }
    return {
        
        'apiResources': !exists(json, 'apiResources') ? undefined : json['apiResources'],
        'approvalType': !exists(json, 'approvalType') ? undefined : json['approvalType'],
        'attributes': !exists(json, 'attributes') ? undefined : ((json['attributes'] as Array<any>).map(ApigeeAttributeFromJSON)),
        'createdAt': !exists(json, 'createdAt') ? undefined : json['createdAt'],
        'description': !exists(json, 'description') ? undefined : json['description'],
        'displayName': !exists(json, 'displayName') ? undefined : json['displayName'],
        'environments': !exists(json, 'environments') ? undefined : json['environments'],
        'graphqlOperationGroup': !exists(json, 'graphqlOperationGroup') ? undefined : ApigeeGraphQLOperationGroupFromJSON(json['graphqlOperationGroup']),
        'lastModifiedAt': !exists(json, 'lastModifiedAt') ? undefined : json['lastModifiedAt'],
        'name': !exists(json, 'name') ? undefined : json['name'],
        'operationGroup': !exists(json, 'operationGroup') ? undefined : ApigeeOperationGroupFromJSON(json['operationGroup']),
        'proxies': !exists(json, 'proxies') ? undefined : json['proxies'],
        'quota': !exists(json, 'quota') ? undefined : json['quota'],
        'quotaInterval': !exists(json, 'quotaInterval') ? undefined : json['quotaInterval'],
        'quotaTimeUnit': !exists(json, 'quotaTimeUnit') ? undefined : json['quotaTimeUnit'],
        'scopes': !exists(json, 'scopes') ? undefined : json['scopes'],
    };
}

export function ApigeeProductToJSON(value?: ApigeeProduct | null): any {
    if (value === undefined) {
        return undefined;
    }
    if (value === null) {
        return null;
    }
    return {
        
        'apiResources': value.apiResources,
        'approvalType': value.approvalType,
        'attributes': value.attributes === undefined ? undefined : ((value.attributes as Array<any>).map(ApigeeAttributeToJSON)),
        'createdAt': value.createdAt,
        'description': value.description,
        'displayName': value.displayName,
        'environments': value.environments,
        'graphqlOperationGroup': ApigeeGraphQLOperationGroupToJSON(value.graphqlOperationGroup),
        'lastModifiedAt': value.lastModifiedAt,
        'name': value.name,
        'operationGroup': ApigeeOperationGroupToJSON(value.operationGroup),
        'proxies': value.proxies,
        'quota': value.quota,
        'quotaInterval': value.quotaInterval,
        'quotaTimeUnit': value.quotaTimeUnit,
        'scopes': value.scopes,
    };
}


