//@ts-nocheck
/* tslint:disable */
/* eslint-disable */
/**
 * Runtime Common Library
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { exists, mapValues } from '../runtime';
import {
    ApigeeQueryMetric,
    ApigeeQueryMetricFromJSON,
    ApigeeQueryMetricFromJSONTyped,
    ApigeeQueryMetricToJSON,
} from './';

/**
 * 
 * @export
 * @interface ApigeeQuery
 */
export interface ApigeeQuery {
    /**
     * Delimiter used in the CSV file, if `outputFormat` is set to `csv`. Defaults to the `,` (comma) character. Supported delimiter characters include comma (`,`), pipe (`|`), and tab (`\t`).
     * @type {string}
     * @memberof ApigeeQuery
     */
    csvDelimiter?: string;
    /**
     * A list of dimensions. https://docs.apigee.com/api-platform/analytics/analytics-reference#dimensions
     * @type {Array<string>}
     * @memberof ApigeeQuery
     */
    dimensions?: Array<string>;
    /**
     * Hostname needs to be specified if query intends to run at host level. This field is only allowed when query is submitted by CreateHostAsyncQuery where analytics data will be grouped by organization and hostname.
     * @type {string}
     * @memberof ApigeeQuery
     */
    envgroupHostname?: string;
    /**
     * Boolean expression that can be used to filter data. Filter expressions can be combined using AND/OR terms and should be fully parenthesized to avoid ambiguity. See Analytics metrics, dimensions, and filters reference https://docs.apigee.com/api-platform/analytics/analytics-reference for more information on the fields available to filter on. For more information on the tokens that you use to build filter expressions, see Filter expression syntax. https://docs.apigee.com/api-platform/analytics/asynch-reports-api#filter-expression-syntax
     * @type {string}
     * @memberof ApigeeQuery
     */
    filter?: string;
    /**
     * Time unit used to group the result set. Valid values include: second, minute, hour, day, week, or month. If a query includes groupByTimeUnit, then the result is an aggregation based on the specified time unit and the resultant timestamp does not include milliseconds precision. If a query omits groupByTimeUnit, then the resultant timestamp includes milliseconds precision.
     * @type {string}
     * @memberof ApigeeQuery
     */
    groupByTimeUnit?: string;
    /**
     * Maximum number of rows that can be returned in the result.
     * @type {number}
     * @memberof ApigeeQuery
     */
    limit?: number;
    /**
     * A list of Metrics.
     * @type {Array<ApigeeQueryMetric>}
     * @memberof ApigeeQuery
     */
    metrics?: Array<ApigeeQueryMetric>;
    /**
     * Asynchronous Query Name.
     * @type {string}
     * @memberof ApigeeQuery
     */
    name?: string;
    /**
     * Valid values include: `csv` or `json`. Defaults to `json`. Note: Configure the delimiter for CSV output using the csvDelimiter property.
     * @type {string}
     * @memberof ApigeeQuery
     */
    outputFormat?: string;
    /**
     * Asynchronous Report ID.
     * @type {string}
     * @memberof ApigeeQuery
     */
    reportDefinitionId?: string;
    /**
     * Required. Time range for the query. Can use the following predefined strings to specify the time range: `last60minutes` `last24hours` `last7days` Or, specify the timeRange as a structure describing start and end timestamps in the ISO format: yyyy-mm-ddThh:mm:ssZ. Example: "timeRange": { "start": "2018-07-29T00:13:00Z", "end": "2018-08-01T00:18:00Z" }
     * @type {string}
     * @memberof ApigeeQuery
     */
    timeRange?: ApigeeQueryTimeRangeEnum;
}

/**
* @export
* @enum {string}
*/
export enum ApigeeQueryTimeRangeEnum {
    Last24hours = 'last24hours',
    Last60minutes = 'last60minutes',
    Last7days = 'last7days'
}

export function ApigeeQueryFromJSON(json: any): ApigeeQuery {
    return ApigeeQueryFromJSONTyped(json, false);
}

export function ApigeeQueryFromJSONTyped(json: any, ignoreDiscriminator: boolean): ApigeeQuery {
    if ((json === undefined) || (json === null)) {
        return json;
    }
    return {
        
        'csvDelimiter': !exists(json, 'csvDelimiter') ? undefined : json['csvDelimiter'],
        'dimensions': !exists(json, 'dimensions') ? undefined : json['dimensions'],
        'envgroupHostname': !exists(json, 'envgroupHostname') ? undefined : json['envgroupHostname'],
        'filter': !exists(json, 'filter') ? undefined : json['filter'],
        'groupByTimeUnit': !exists(json, 'groupByTimeUnit') ? undefined : json['groupByTimeUnit'],
        'limit': !exists(json, 'limit') ? undefined : json['limit'],
        'metrics': !exists(json, 'metrics') ? undefined : ((json['metrics'] as Array<any>).map(ApigeeQueryMetricFromJSON)),
        'name': !exists(json, 'name') ? undefined : json['name'],
        'outputFormat': !exists(json, 'outputFormat') ? undefined : json['outputFormat'],
        'reportDefinitionId': !exists(json, 'reportDefinitionId') ? undefined : json['reportDefinitionId'],
        'timeRange': !exists(json, 'timeRange') ? undefined : json['timeRange'],
    };
}

export function ApigeeQueryToJSON(value?: ApigeeQuery | null): any {
    if (value === undefined) {
        return undefined;
    }
    if (value === null) {
        return null;
    }
    return {
        
        'csvDelimiter': value.csvDelimiter,
        'dimensions': value.dimensions,
        'envgroupHostname': value.envgroupHostname,
        'filter': value.filter,
        'groupByTimeUnit': value.groupByTimeUnit,
        'limit': value.limit,
        'metrics': value.metrics === undefined ? undefined : ((value.metrics as Array<any>).map(ApigeeQueryMetricToJSON)),
        'name': value.name,
        'outputFormat': value.outputFormat,
        'reportDefinitionId': value.reportDefinitionId,
        'timeRange': value.timeRange,
    };
}


