//@ts-nocheck
/* tslint:disable */
/* eslint-disable */
/**
 * This is an open API that holds specific endpoints as a base for Pieces Context Systems
 * The point of this API is to allow us to organize and Auto Generate Code Specific for Connected Applications - this will allow for stateful context abstraction & less code within the Core Connector
 *
 * The version of the OpenAPI document: 1.0
 * Contact: tsavo@pieces.app
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { exists, mapValues } from '../runtime';
import {
    EmbeddedModelSchema,
    EmbeddedModelSchemaFromJSON,
    EmbeddedModelSchemaFromJSONTyped,
    EmbeddedModelSchemaToJSON,
    GroupedTimestamp,
    GroupedTimestampFromJSON,
    GroupedTimestampFromJSONTyped,
    GroupedTimestampToJSON,
    MechanismEnum,
    MechanismEnumFromJSON,
    MechanismEnumFromJSONTyped,
    MechanismEnumToJSON,
    PersonAccess,
    PersonAccessFromJSON,
    PersonAccessFromJSONTyped,
    PersonAccessToJSON,
    PersonType,
    PersonTypeFromJSON,
    PersonTypeFromJSONTyped,
    PersonTypeToJSON,
    ReferencedAsset,
    ReferencedAssetFromJSON,
    ReferencedAssetFromJSONTyped,
    ReferencedAssetToJSON,
} from './';

/**
 * if expiration is add then, after the alloted expiration date the user will only have view && comment only permissions. Only present in the case there is a scope such as a defined collection/asset...
 * 
 * if asset is passed then that means this person belongs to a scoped asset.
 * @export
 * @interface FlattenedPerson
 */
export interface FlattenedPerson {
    /**
     * 
     * @type {EmbeddedModelSchema}
     * @memberof FlattenedPerson
     */
    schema?: EmbeddedModelSchema;
    /**
     * 
     * @type {string}
     * @memberof FlattenedPerson
     */
    id: string;
    /**
     * 
     * @type {GroupedTimestamp}
     * @memberof FlattenedPerson
     */
    created: GroupedTimestamp;
    /**
     * 
     * @type {GroupedTimestamp}
     * @memberof FlattenedPerson
     */
    updated: GroupedTimestamp;
    /**
     * 
     * @type {GroupedTimestamp}
     * @memberof FlattenedPerson
     */
    deleted?: GroupedTimestamp;
    /**
     * 
     * @type {PersonAccess}
     * @memberof FlattenedPerson
     */
    access: PersonAccess;
    /**
     * 
     * @type {GroupedTimestamp}
     * @memberof FlattenedPerson
     */
    expiration?: GroupedTimestamp;
    /**
     * 
     * @type {PersonType}
     * @memberof FlattenedPerson
     */
    type: PersonType;
    /**
     * 
     * @type {ReferencedAsset}
     * @memberof FlattenedPerson
     */
    asset?: ReferencedAsset;
    /**
     * 
     * @type {MechanismEnum}
     * @memberof FlattenedPerson
     */
    mechanism: MechanismEnum;
    /**
     * This is an optional value that will keep track of the number of times this has been interacted with.
     * @type {number}
     * @memberof FlattenedPerson
     */
    interactions?: number;
}

export function FlattenedPersonFromJSON(json: any): FlattenedPerson {
    return FlattenedPersonFromJSONTyped(json, false);
}

export function FlattenedPersonFromJSONTyped(json: any, ignoreDiscriminator: boolean): FlattenedPerson {
    if ((json === undefined) || (json === null)) {
        return json;
    }
    return {
        
        'schema': !exists(json, 'schema') ? undefined : EmbeddedModelSchemaFromJSON(json['schema']),
        'id': json['id'],
        'created': GroupedTimestampFromJSON(json['created']),
        'updated': GroupedTimestampFromJSON(json['updated']),
        'deleted': !exists(json, 'deleted') ? undefined : GroupedTimestampFromJSON(json['deleted']),
        'access': PersonAccessFromJSON(json['access']),
        'expiration': !exists(json, 'expiration') ? undefined : GroupedTimestampFromJSON(json['expiration']),
        'type': PersonTypeFromJSON(json['type']),
        'asset': !exists(json, 'asset') ? undefined : ReferencedAssetFromJSON(json['asset']),
        'mechanism': MechanismEnumFromJSON(json['mechanism']),
        'interactions': !exists(json, 'interactions') ? undefined : json['interactions'],
    };
}

export function FlattenedPersonToJSON(value?: FlattenedPerson | null): any {
    if (value === undefined) {
        return undefined;
    }
    if (value === null) {
        return null;
    }
    return {
        
        'schema': EmbeddedModelSchemaToJSON(value.schema),
        'id': value.id,
        'created': GroupedTimestampToJSON(value.created),
        'updated': GroupedTimestampToJSON(value.updated),
        'deleted': GroupedTimestampToJSON(value.deleted),
        'access': PersonAccessToJSON(value.access),
        'expiration': GroupedTimestampToJSON(value.expiration),
        'type': PersonTypeToJSON(value.type),
        'asset': ReferencedAssetToJSON(value.asset),
        'mechanism': MechanismEnumToJSON(value.mechanism),
        'interactions': value.interactions,
    };
}


