//@ts-nocheck
/* tslint:disable */
/* eslint-disable */
/**
 * This is an open API that holds specific endpoints as a base for Pieces Context Systems
 * The point of this API is to allow us to organize and Auto Generate Code Specific for Connected Applications - this will allow for stateful context abstraction & less code within the Core Connector
 *
 * The version of the OpenAPI document: 1.0
 * Contact: tsavo@pieces.app
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { exists, mapValues } from '../runtime';
import {
    Activities,
    ActivitiesFromJSON,
    ActivitiesFromJSONTyped,
    ActivitiesToJSON,
    Analysis,
    AnalysisFromJSON,
    AnalysisFromJSONTyped,
    AnalysisToJSON,
    Application,
    ApplicationFromJSON,
    ApplicationFromJSONTyped,
    ApplicationToJSON,
    ByteDescriptor,
    ByteDescriptorFromJSON,
    ByteDescriptorFromJSONTyped,
    ByteDescriptorToJSON,
    Classification,
    ClassificationFromJSON,
    ClassificationFromJSONTyped,
    ClassificationToJSON,
    EmbeddedModelSchema,
    EmbeddedModelSchemaFromJSON,
    EmbeddedModelSchemaFromJSONTyped,
    EmbeddedModelSchemaToJSON,
    FileFormat,
    FileFormatFromJSON,
    FileFormatFromJSONTyped,
    FileFormatToJSON,
    FlattenedAsset,
    FlattenedAssetFromJSON,
    FlattenedAssetFromJSONTyped,
    FlattenedAssetToJSON,
    FragmentFormat,
    FragmentFormatFromJSON,
    FragmentFormatFromJSONTyped,
    FragmentFormatToJSON,
    GroupedTimestamp,
    GroupedTimestampFromJSON,
    GroupedTimestampFromJSONTyped,
    GroupedTimestampToJSON,
    Relationship,
    RelationshipFromJSON,
    RelationshipFromJSONTyped,
    RelationshipToJSON,
    Role,
    RoleFromJSON,
    RoleFromJSONTyped,
    RoleToJSON,
    Tags,
    TagsFromJSON,
    TagsFromJSONTyped,
    TagsToJSON,
    Websites,
    WebsitesFromJSON,
    WebsitesFromJSONTyped,
    WebsitesToJSON,
} from './';

/**
 * A representation of Data for a particular Form Factor of an Asset.
 * 
 * Below asset HAS to be Flattened because it is a leaf node and must prevent cycles agressively.
 * @export
 * @interface Format
 */
export interface Format {
    /**
     * 
     * @type {EmbeddedModelSchema}
     * @memberof Format
     */
    schema?: EmbeddedModelSchema;
    /**
     * 
     * @type {string}
     * @memberof Format
     */
    id: string;
    /**
     * 
     * @type {string}
     * @memberof Format
     */
    creator: string;
    /**
     * 
     * @type {Classification}
     * @memberof Format
     */
    classification: Classification;
    /**
     * 
     * @type {string}
     * @memberof Format
     */
    icon?: string;
    /**
     * 
     * @type {Role}
     * @memberof Format
     */
    role: Role;
    /**
     * 
     * @type {Application}
     * @memberof Format
     */
    application: Application;
    /**
     * 
     * @type {FlattenedAsset}
     * @memberof Format
     */
    asset: FlattenedAsset;
    /**
     * 
     * @type {ByteDescriptor}
     * @memberof Format
     */
    bytes: ByteDescriptor;
    /**
     * 
     * @type {GroupedTimestamp}
     * @memberof Format
     */
    created: GroupedTimestamp;
    /**
     * 
     * @type {GroupedTimestamp}
     * @memberof Format
     */
    updated: GroupedTimestamp;
    /**
     * 
     * @type {GroupedTimestamp}
     * @memberof Format
     */
    deleted?: GroupedTimestamp;
    /**
     * 
     * @type {GroupedTimestamp}
     * @memberof Format
     */
    synced?: GroupedTimestamp;
    /**
     * This is a path used to determine what path this format lives at within the cloud.
     * @type {string}
     * @memberof Format
     */
    cloud?: string;
    /**
     * 
     * @type {FragmentFormat}
     * @memberof Format
     */
    fragment?: FragmentFormat;
    /**
     * 
     * @type {FileFormat}
     * @memberof Format
     */
    file?: FileFormat;
    /**
     * 
     * @type {Analysis}
     * @memberof Format
     */
    analysis?: Analysis;
    /**
     * 
     * @type {Websites}
     * @memberof Format
     */
    websites?: Websites;
    /**
     * 
     * @type {Tags}
     * @memberof Format
     */
    tags?: Tags;
    /**
     * 
     * @type {Relationship}
     * @memberof Format
     */
    relationship?: Relationship;
    /**
     * 
     * @type {Activities}
     * @memberof Format
     */
    activities?: Activities;
}

export function FormatFromJSON(json: any): Format {
    return FormatFromJSONTyped(json, false);
}

export function FormatFromJSONTyped(json: any, ignoreDiscriminator: boolean): Format {
    if ((json === undefined) || (json === null)) {
        return json;
    }
    return {
        
        'schema': !exists(json, 'schema') ? undefined : EmbeddedModelSchemaFromJSON(json['schema']),
        'id': json['id'],
        'creator': json['creator'],
        'classification': ClassificationFromJSON(json['classification']),
        'icon': !exists(json, 'icon') ? undefined : json['icon'],
        'role': RoleFromJSON(json['role']),
        'application': ApplicationFromJSON(json['application']),
        'asset': FlattenedAssetFromJSON(json['asset']),
        'bytes': ByteDescriptorFromJSON(json['bytes']),
        'created': GroupedTimestampFromJSON(json['created']),
        'updated': GroupedTimestampFromJSON(json['updated']),
        'deleted': !exists(json, 'deleted') ? undefined : GroupedTimestampFromJSON(json['deleted']),
        'synced': !exists(json, 'synced') ? undefined : GroupedTimestampFromJSON(json['synced']),
        'cloud': !exists(json, 'cloud') ? undefined : json['cloud'],
        'fragment': !exists(json, 'fragment') ? undefined : FragmentFormatFromJSON(json['fragment']),
        'file': !exists(json, 'file') ? undefined : FileFormatFromJSON(json['file']),
        'analysis': !exists(json, 'analysis') ? undefined : AnalysisFromJSON(json['analysis']),
        'websites': !exists(json, 'websites') ? undefined : WebsitesFromJSON(json['websites']),
        'tags': !exists(json, 'tags') ? undefined : TagsFromJSON(json['tags']),
        'relationship': !exists(json, 'relationship') ? undefined : RelationshipFromJSON(json['relationship']),
        'activities': !exists(json, 'activities') ? undefined : ActivitiesFromJSON(json['activities']),
    };
}

export function FormatToJSON(value?: Format | null): any {
    if (value === undefined) {
        return undefined;
    }
    if (value === null) {
        return null;
    }
    return {
        
        'schema': EmbeddedModelSchemaToJSON(value.schema),
        'id': value.id,
        'creator': value.creator,
        'classification': ClassificationToJSON(value.classification),
        'icon': value.icon,
        'role': RoleToJSON(value.role),
        'application': ApplicationToJSON(value.application),
        'asset': FlattenedAssetToJSON(value.asset),
        'bytes': ByteDescriptorToJSON(value.bytes),
        'created': GroupedTimestampToJSON(value.created),
        'updated': GroupedTimestampToJSON(value.updated),
        'deleted': GroupedTimestampToJSON(value.deleted),
        'synced': GroupedTimestampToJSON(value.synced),
        'cloud': value.cloud,
        'fragment': FragmentFormatToJSON(value.fragment),
        'file': FileFormatToJSON(value.file),
        'analysis': AnalysisToJSON(value.analysis),
        'websites': WebsitesToJSON(value.websites),
        'tags': TagsToJSON(value.tags),
        'relationship': RelationshipToJSON(value.relationship),
        'activities': ActivitiesToJSON(value.activities),
    };
}


