//@ts-nocheck
/* tslint:disable */
/* eslint-disable */
/**
 * This is an open API that holds specific endpoints as a base for Pieces Context Systems
 * The point of this API is to allow us to organize and Auto Generate Code Specific for Connected Applications - this will allow for stateful context abstraction & less code within the Core Connector
 *
 * The version of the OpenAPI document: 1.0
 * Contact: tsavo@pieces.app
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { exists, mapValues } from '../runtime';
import {
    Assets,
    AssetsFromJSON,
    AssetsFromJSONTyped,
    AssetsToJSON,
    EmbeddedModelSchema,
    EmbeddedModelSchemaFromJSON,
    EmbeddedModelSchemaFromJSONTyped,
    EmbeddedModelSchemaToJSON,
    ReuseSuggestion,
    ReuseSuggestionFromJSON,
    ReuseSuggestionFromJSONTyped,
    ReuseSuggestionToJSON,
    SaveSuggestion,
    SaveSuggestionFromJSON,
    SaveSuggestionFromJSONTyped,
    SaveSuggestionToJSON,
    SuggestionTarget,
    SuggestionTargetFromJSON,
    SuggestionTargetFromJSONTyped,
    SuggestionTargetToJSON,
} from './';

/**
 * This is the model return by the connector's suggest endpoint.
 * 
 * Note:
 * assets are the assets that this target was ran against.
 * 
 * distribution is the distribution that we generated from comparing the target to the asset's vectors.(currently uuid(assetid) : value that is the difference between the asset and the target) **could potentially make an additional model here that is an array from most to least relevent.
 * 
 * *** distribution is required but we are currently unable to reflect that with our current dart generation.
 * @export
 * @interface Suggestion
 */
export interface Suggestion {
    /**
     * 
     * @type {EmbeddedModelSchema}
     * @memberof Suggestion
     */
    schema?: EmbeddedModelSchema;
    /**
     * 
     * @type {ReuseSuggestion}
     * @memberof Suggestion
     */
    reuse: ReuseSuggestion;
    /**
     * 
     * @type {SaveSuggestion}
     * @memberof Suggestion
     */
    save: SaveSuggestion;
    /**
     * 
     * @type {SuggestionTarget}
     * @memberof Suggestion
     */
    target: SuggestionTarget;
    /**
     * 
     * @type {Assets}
     * @memberof Suggestion
     */
    assets: Assets;
    /**
     * 
     * @type {{ [key: string]: number; }}
     * @memberof Suggestion
     */
    distribution?: { [key: string]: number; };
}

export function SuggestionFromJSON(json: any): Suggestion {
    return SuggestionFromJSONTyped(json, false);
}

export function SuggestionFromJSONTyped(json: any, ignoreDiscriminator: boolean): Suggestion {
    if ((json === undefined) || (json === null)) {
        return json;
    }
    return {
        
        'schema': !exists(json, 'schema') ? undefined : EmbeddedModelSchemaFromJSON(json['schema']),
        'reuse': ReuseSuggestionFromJSON(json['reuse']),
        'save': SaveSuggestionFromJSON(json['save']),
        'target': SuggestionTargetFromJSON(json['target']),
        'assets': AssetsFromJSON(json['assets']),
        'distribution': !exists(json, 'distribution') ? undefined : json['distribution'],
    };
}

export function SuggestionToJSON(value?: Suggestion | null): any {
    if (value === undefined) {
        return undefined;
    }
    if (value === null) {
        return null;
    }
    return {
        
        'schema': EmbeddedModelSchemaToJSON(value.schema),
        'reuse': ReuseSuggestionToJSON(value.reuse),
        'save': SaveSuggestionToJSON(value.save),
        'target': SuggestionTargetToJSON(value.target),
        'assets': AssetsToJSON(value.assets),
        'distribution': value.distribution,
    };
}


