//@ts-nocheck
/* tslint:disable */
/* eslint-disable */
/**
 * Pieces Isomorphic OpenAPI
 * Endpoints for Assets, Formats, Users, Asset, Format, User.
 *
 * The version of the OpenAPI document: 1.0
 * Contact: tsavo@pieces.app
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import * as runtime from '../runtime';
import {
    Analysis,
    AnalysisFromJSON,
    AnalysisToJSON,
    Format,
    FormatFromJSON,
    FormatToJSON,
    FormatReclassification,
    FormatReclassificationFromJSON,
    FormatReclassificationToJSON,
    SeededTrackedFormatEvent,
    SeededTrackedFormatEventFromJSON,
    SeededTrackedFormatEventToJSON,
    TrackedFormatEvent,
    TrackedFormatEventFromJSON,
    TrackedFormatEventToJSON,
} from '../models';

export interface FormatAnalysisRequest {
    format: string;
}

export interface FormatReclassifyRequest {
    transferable?: boolean;
    formatReclassification?: FormatReclassification;
}

export interface FormatSnapshotRequest {
    format: string;
    transferable?: boolean;
}

export interface FormatUpdateValueRequest {
    transferable?: boolean;
    format?: Format;
}

export interface FormatUsageEventRequest {
    seededTrackedFormatEvent?: SeededTrackedFormatEvent;
}

/**
 * 
 */
export class FormatApi extends runtime.BaseAPI {

    /**
     * This will get an analysis from a format\'s id.
     * /format/{format}/analysis [GET]
     */
    async formatAnalysisRaw(requestParameters: FormatAnalysisRequest): Promise<runtime.ApiResponse<Analysis>> {
        if (requestParameters.format === null || requestParameters.format === undefined) {
            throw new runtime.RequiredError('format','Required parameter requestParameters.format was null or undefined when calling formatAnalysis.');
        }

        const queryParameters: any = {};

        const headerParameters: runtime.HTTPHeaders = {};

        const response = await this.request({
            path: `/format/{format}/analysis`.replace(`{${"format"}}`, encodeURIComponent(String(requestParameters.format))),
            method: 'GET',
            headers: headerParameters,
            query: queryParameters,
        });

        return new runtime.JSONApiResponse(response, (jsonValue) => AnalysisFromJSON(jsonValue));
    }

    /**
     * This will get an analysis from a format\'s id.
     * /format/{format}/analysis [GET]
     */
    async formatAnalysis(requestParameters: FormatAnalysisRequest): Promise<Analysis> {
        const response = await this.formatAnalysisRaw(requestParameters);
        return await response.value();
    }

    /**
     * This endpoint will be used to reclassify a single Format.
     * /format/reclassify [POST]
     */
    async formatReclassifyRaw(requestParameters: FormatReclassifyRequest): Promise<runtime.ApiResponse<Format>> {
        const queryParameters: any = {};

        if (requestParameters.transferable !== undefined) {
            queryParameters['transferable'] = requestParameters.transferable;
        }

        const headerParameters: runtime.HTTPHeaders = {};

        headerParameters['Content-Type'] = 'application/json';

        const response = await this.request({
            path: `/format/reclassify`,
            method: 'POST',
            headers: headerParameters,
            query: queryParameters,
            body: FormatReclassificationToJSON(requestParameters.formatReclassification),
        });

        return new runtime.JSONApiResponse(response, (jsonValue) => FormatFromJSON(jsonValue));
    }

    /**
     * This endpoint will be used to reclassify a single Format.
     * /format/reclassify [POST]
     */
    async formatReclassify(requestParameters: FormatReclassifyRequest): Promise<Format> {
        const response = await this.formatReclassifyRaw(requestParameters);
        return await response.value();
    }

    /**
     * Get a snapshot of a specific format.
     * /format/{format} [GET] Scoped to Format
     */
    async formatSnapshotRaw(requestParameters: FormatSnapshotRequest): Promise<runtime.ApiResponse<Format>> {
        if (requestParameters.format === null || requestParameters.format === undefined) {
            throw new runtime.RequiredError('format','Required parameter requestParameters.format was null or undefined when calling formatSnapshot.');
        }

        const queryParameters: any = {};

        if (requestParameters.transferable !== undefined) {
            queryParameters['transferable'] = requestParameters.transferable;
        }

        const headerParameters: runtime.HTTPHeaders = {};

        const response = await this.request({
            path: `/format/{format}`.replace(`{${"format"}}`, encodeURIComponent(String(requestParameters.format))),
            method: 'GET',
            headers: headerParameters,
            query: queryParameters,
        });

        return new runtime.JSONApiResponse(response, (jsonValue) => FormatFromJSON(jsonValue));
    }

    /**
     * Get a snapshot of a specific format.
     * /format/{format} [GET] Scoped to Format
     */
    async formatSnapshot(requestParameters: FormatSnapshotRequest): Promise<Format> {
        const response = await this.formatSnapshotRaw(requestParameters);
        return await response.value();
    }

    /**
     * This will update a format\'s value, ie, a formats fragment or file depending on what is provided.  code/text fragment behavior: If this format is an asset.preview.base we will update the asset.original\'s value. if this format is an asset.preview.original we will update the asset.preview.base\'s value.  code/text file behavior: If the the format that is update is the asset.preview.base is a fragment and the asset.original is file then we will update the asset.original\'s value to be bytes or string respectively. This goes the same for orignal to preview but will be go the reverse order so if the original is a file we will update the preview base\'s fragment string.  image fragment/file: We will not modify preview -> orignal or original -> preview here. so there are zero side effects in this case, and will update as normal. (this will be the case for all other value updates.)
     * [POST] /format/update/value
     */
    async formatUpdateValueRaw(requestParameters: FormatUpdateValueRequest): Promise<runtime.ApiResponse<Format>> {
        const queryParameters: any = {};

        if (requestParameters.transferable !== undefined) {
            queryParameters['transferable'] = requestParameters.transferable;
        }

        const headerParameters: runtime.HTTPHeaders = {};

        headerParameters['Content-Type'] = 'application/json';

        const response = await this.request({
            path: `/format/update/value`,
            method: 'POST',
            headers: headerParameters,
            query: queryParameters,
            body: FormatToJSON(requestParameters.format),
        });

        return new runtime.JSONApiResponse(response, (jsonValue) => FormatFromJSON(jsonValue));
    }

    /**
     * This will update a format\'s value, ie, a formats fragment or file depending on what is provided.  code/text fragment behavior: If this format is an asset.preview.base we will update the asset.original\'s value. if this format is an asset.preview.original we will update the asset.preview.base\'s value.  code/text file behavior: If the the format that is update is the asset.preview.base is a fragment and the asset.original is file then we will update the asset.original\'s value to be bytes or string respectively. This goes the same for orignal to preview but will be go the reverse order so if the original is a file we will update the preview base\'s fragment string.  image fragment/file: We will not modify preview -> orignal or original -> preview here. so there are zero side effects in this case, and will update as normal. (this will be the case for all other value updates.)
     * [POST] /format/update/value
     */
    async formatUpdateValue(requestParameters: FormatUpdateValueRequest): Promise<Format> {
        const response = await this.formatUpdateValueRaw(requestParameters);
        return await response.value();
    }

    /**
     * This is an analytics endpoint that will enable us to know when a user has copied/downloaded/beamed/viewed a format.
     * /format/usage/event [POST] Scoped to Format
     */
    async formatUsageEventRaw(requestParameters: FormatUsageEventRequest): Promise<runtime.ApiResponse<TrackedFormatEvent>> {
        const queryParameters: any = {};

        const headerParameters: runtime.HTTPHeaders = {};

        headerParameters['Content-Type'] = 'application/json';

        const response = await this.request({
            path: `/format/usage/event`,
            method: 'POST',
            headers: headerParameters,
            query: queryParameters,
            body: SeededTrackedFormatEventToJSON(requestParameters.seededTrackedFormatEvent),
        });

        return new runtime.JSONApiResponse(response, (jsonValue) => TrackedFormatEventFromJSON(jsonValue));
    }

    /**
     * This is an analytics endpoint that will enable us to know when a user has copied/downloaded/beamed/viewed a format.
     * /format/usage/event [POST] Scoped to Format
     */
    async formatUsageEvent(requestParameters: FormatUsageEventRequest): Promise<TrackedFormatEvent> {
        const response = await this.formatUsageEventRaw(requestParameters);
        return await response.value();
    }

}
