//@ts-nocheck
/* tslint:disable */
/* eslint-disable */
/**
 * Pieces Isomorphic OpenAPI
 * Endpoints for Assets, Formats, Users, Asset, Format, User.
 *
 * The version of the OpenAPI document: 1.0
 * Contact: tsavo@pieces.app
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import * as runtime from '../runtime';
import {
    QGPTHintsInput,
    QGPTHintsInputFromJSON,
    QGPTHintsInputToJSON,
    QGPTQuestionInput,
    QGPTQuestionInputFromJSON,
    QGPTQuestionInputToJSON,
    QGPTQuestionOutput,
    QGPTQuestionOutputFromJSON,
    QGPTQuestionOutputToJSON,
    QGPTRelevanceInput,
    QGPTRelevanceInputFromJSON,
    QGPTRelevanceInputToJSON,
    QGPTRelevanceOutput,
    QGPTRelevanceOutputFromJSON,
    QGPTRelevanceOutputToJSON,
    QGPTRepromptInput,
    QGPTRepromptInputFromJSON,
    QGPTRepromptInputToJSON,
    QGPTRepromptOutput,
    QGPTRepromptOutputFromJSON,
    QGPTRepromptOutputToJSON,
} from '../models';

export interface HintsRequest {
    qGPTHintsInput?: QGPTHintsInput;
}

export interface QuestionRequest {
    qGPTQuestionInput?: QGPTQuestionInput;
}

export interface RelevanceRequest {
    qGPTRelevanceInput?: QGPTRelevanceInput;
}

export interface RepromptRequest {
    qGPTRepromptInput?: QGPTRepromptInput;
}

/**
 * 
 */
export class QGPTApi extends runtime.BaseAPI {

    /**
     * This is only to generate suggested questions that the user can ask. ( we will provide the answer we displayed to the user, the relevant snippets used for the answer, and the previous query.  We will return a list of questions that can be displayed to the user.
     * /qgpt/hints [POST]
     */
    async hintsRaw(requestParameters: HintsRequest): Promise<runtime.ApiResponse<QGPTQuestionOutput>> {
        const queryParameters: any = {};

        const headerParameters: runtime.HTTPHeaders = {};

        headerParameters['Content-Type'] = 'application/json';

        const response = await this.request({
            path: `/qgpt/hints`,
            method: 'POST',
            headers: headerParameters,
            query: queryParameters,
            body: QGPTHintsInputToJSON(requestParameters.qGPTHintsInput),
        });

        return new runtime.JSONApiResponse(response, (jsonValue) => QGPTQuestionOutputFromJSON(jsonValue));
    }

    /**
     * This is only to generate suggested questions that the user can ask. ( we will provide the answer we displayed to the user, the relevant snippets used for the answer, and the previous query.  We will return a list of questions that can be displayed to the user.
     * /qgpt/hints [POST]
     */
    async hints(requestParameters: HintsRequest): Promise<QGPTQuestionOutput> {
        const response = await this.hintsRaw(requestParameters);
        return await response.value();
    }

    /**
     * This is going to accept, relevant code snippets or uuids returned from the /qgpt/relevance endpoint, as well as a question query and we will return possible results to answer your question.  NOTE: - The relevant seeds, must require either an id, that was used within the /qgpt/relevance endpoint or a seed with afragment/string. or else we will throw and error.  This endpoint will take your query and your relevant snippets and use them to answer your question, returning multiple answers to your question all of which with scores.
     * /qgpt/question [POST]
     */
    async questionRaw(requestParameters: QuestionRequest): Promise<runtime.ApiResponse<QGPTQuestionOutput>> {
        const queryParameters: any = {};

        const headerParameters: runtime.HTTPHeaders = {};

        headerParameters['Content-Type'] = 'application/json';

        const response = await this.request({
            path: `/qgpt/question`,
            method: 'POST',
            headers: headerParameters,
            query: queryParameters,
            body: QGPTQuestionInputToJSON(requestParameters.qGPTQuestionInput),
        });

        return new runtime.JSONApiResponse(response, (jsonValue) => QGPTQuestionOutputFromJSON(jsonValue));
    }

    /**
     * This is going to accept, relevant code snippets or uuids returned from the /qgpt/relevance endpoint, as well as a question query and we will return possible results to answer your question.  NOTE: - The relevant seeds, must require either an id, that was used within the /qgpt/relevance endpoint or a seed with afragment/string. or else we will throw and error.  This endpoint will take your query and your relevant snippets and use them to answer your question, returning multiple answers to your question all of which with scores.
     * /qgpt/question [POST]
     */
    async question(requestParameters: QuestionRequest): Promise<QGPTQuestionOutput> {
        const response = await this.questionRaw(requestParameters);
        return await response.value();
    }

    /**
     * This is the first phase to the QGPT flow.  Please one of the following. 1. provide an absolute path on the users machine that we can use locally. 2. provide Seeds that you want to compare to, which will be ONLY fragment/string values(all other values will be ignored) 3. provide assets, here you can provide an iterable of the asset id, and we will do the rest 4. you can set your database boolean to true which will tell us to use your entire DB as the query space.  required - query: string; This is the question of the user. optional - question: boolean; This will by-pass the second endpoint and just ask the question and return the results(as an ease of use bool)  This endpoint will embed everything. and will return the relevance snippets that we will use in the next phase, to answer your question.  on the UI: we can show this to users (around this is the snippets we used to answer your question.)  Next: feed this information to the /qgpt/question [POST] endpoint to get your question answered.(unless you included the question:true optional boolean, then you will get the results from here.)
     * /qgpt/relevance [POST]
     */
    async relevanceRaw(requestParameters: RelevanceRequest): Promise<runtime.ApiResponse<QGPTRelevanceOutput>> {
        const queryParameters: any = {};

        const headerParameters: runtime.HTTPHeaders = {};

        headerParameters['Content-Type'] = 'application/json';

        const response = await this.request({
            path: `/qgpt/relevance`,
            method: 'POST',
            headers: headerParameters,
            query: queryParameters,
            body: QGPTRelevanceInputToJSON(requestParameters.qGPTRelevanceInput),
        });

        return new runtime.JSONApiResponse(response, (jsonValue) => QGPTRelevanceOutputFromJSON(jsonValue));
    }

    /**
     * This is the first phase to the QGPT flow.  Please one of the following. 1. provide an absolute path on the users machine that we can use locally. 2. provide Seeds that you want to compare to, which will be ONLY fragment/string values(all other values will be ignored) 3. provide assets, here you can provide an iterable of the asset id, and we will do the rest 4. you can set your database boolean to true which will tell us to use your entire DB as the query space.  required - query: string; This is the question of the user. optional - question: boolean; This will by-pass the second endpoint and just ask the question and return the results(as an ease of use bool)  This endpoint will embed everything. and will return the relevance snippets that we will use in the next phase, to answer your question.  on the UI: we can show this to users (around this is the snippets we used to answer your question.)  Next: feed this information to the /qgpt/question [POST] endpoint to get your question answered.(unless you included the question:true optional boolean, then you will get the results from here.)
     * /qgpt/relevance [POST]
     */
    async relevance(requestParameters: RelevanceRequest): Promise<QGPTRelevanceOutput> {
        const response = await this.relevanceRaw(requestParameters);
        return await response.value();
    }

    /**
     * This will take in a followup question and the history of the conversation, and emit your a prompt or query that you can pass to the /qgpt/relevance and then the /qgpt/question endpoint to get your next answer.
     * /qgpt/reprompt [POST]
     */
    async repromptRaw(requestParameters: RepromptRequest): Promise<runtime.ApiResponse<QGPTRepromptOutput>> {
        const queryParameters: any = {};

        const headerParameters: runtime.HTTPHeaders = {};

        headerParameters['Content-Type'] = 'application/json';

        const response = await this.request({
            path: `/qgpt/reprompt`,
            method: 'POST',
            headers: headerParameters,
            query: queryParameters,
            body: QGPTRepromptInputToJSON(requestParameters.qGPTRepromptInput),
        });

        return new runtime.JSONApiResponse(response, (jsonValue) => QGPTRepromptOutputFromJSON(jsonValue));
    }

    /**
     * This will take in a followup question and the history of the conversation, and emit your a prompt or query that you can pass to the /qgpt/relevance and then the /qgpt/question endpoint to get your next answer.
     * /qgpt/reprompt [POST]
     */
    async reprompt(requestParameters: RepromptRequest): Promise<QGPTRepromptOutput> {
        const response = await this.repromptRaw(requestParameters);
        return await response.value();
    }

}
