//@ts-nocheck
/* tslint:disable */
/* eslint-disable */
/**
 * Pieces Isomorphic OpenAPI
 * Endpoints for Assets, Formats, Users, Asset, Format, User.
 *
 * The version of the OpenAPI document: 1.0
 * Contact: tsavo@pieces.app
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import * as runtime from '../runtime';
import {
    Share,
    ShareFromJSON,
    ShareToJSON,
} from '../models';

export interface ShareSnapshotRequest {
    share: string;
    transferables?: boolean;
}

export interface ShareUpdateRequest {
    transferables?: boolean;
    share?: Share;
}

/**
 * 
 */
export class ShareApi extends runtime.BaseAPI {

    /**
     * Get the snapshot of a specific share.
     * /share/{share}
     */
    async shareSnapshotRaw(requestParameters: ShareSnapshotRequest): Promise<runtime.ApiResponse<Share>> {
        if (requestParameters.share === null || requestParameters.share === undefined) {
            throw new runtime.RequiredError('share','Required parameter requestParameters.share was null or undefined when calling shareSnapshot.');
        }

        const queryParameters: any = {};

        if (requestParameters.transferables !== undefined) {
            queryParameters['transferables'] = requestParameters.transferables;
        }

        const headerParameters: runtime.HTTPHeaders = {};

        const response = await this.request({
            path: `/share/{share}`.replace(`{${"share"}}`, encodeURIComponent(String(requestParameters.share))),
            method: 'GET',
            headers: headerParameters,
            query: queryParameters,
        });

        return new runtime.JSONApiResponse(response, (jsonValue) => ShareFromJSON(jsonValue));
    }

    /**
     * Get the snapshot of a specific share.
     * /share/{share}
     */
    async shareSnapshot(requestParameters: ShareSnapshotRequest): Promise<Share> {
        const response = await this.shareSnapshotRaw(requestParameters);
        return await response.value();
    }

    /**
     * This endpoint will accept a Share that the user wants to update, and will return a full Share that was updated!
     * /share/update [POST]
     */
    async shareUpdateRaw(requestParameters: ShareUpdateRequest): Promise<runtime.ApiResponse<Share>> {
        const queryParameters: any = {};

        if (requestParameters.transferables !== undefined) {
            queryParameters['transferables'] = requestParameters.transferables;
        }

        const headerParameters: runtime.HTTPHeaders = {};

        headerParameters['Content-Type'] = 'application/json';

        const response = await this.request({
            path: `/share/update`,
            method: 'POST',
            headers: headerParameters,
            query: queryParameters,
            body: ShareToJSON(requestParameters.share),
        });

        return new runtime.JSONApiResponse(response, (jsonValue) => ShareFromJSON(jsonValue));
    }

    /**
     * This endpoint will accept a Share that the user wants to update, and will return a full Share that was updated!
     * /share/update [POST]
     */
    async shareUpdate(requestParameters: ShareUpdateRequest): Promise<Share> {
        const response = await this.shareUpdateRaw(requestParameters);
        return await response.value();
    }

}
